      program ana_ehgts ! Bernd Berg Aug 10 2005.
C Reweights double peak to equal heights.
C Prepares energy histogram plots, calculates average energy (action).
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      character cd*1,cq*2,cl*3
      include 'lat.par'
      include 'mc.par'
      include 'potts.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      include 'lat.dat'
      dimension hasum(0:mlink),hae(0:mlink),haj(0:mlink),hbm(0:mlink),
     &  hbe(0:mlink),hbj(0:mlink),bj(0:nrpt),Ratj(0:nrpt),actlj(0:nrpt),
     &  d_actlj(0:nrpt),x(3),y(3),xext(2),maxa(2)
      ltest=.true.
      ltest=.false.
      if(ltest) stop "ana_ehgts: ltest."

      write(cd,'(I1.1)') nd ! Prepare to read the data.
      write(cq,'(I2.2)') nq
      write(cl,'(I3.3)') nla(1)
      open(iud1,file="p"//cd//"d"//cq//"q"//cl//".D",
     &     form="unformatted",status="old")
      read(iud1) beta_in,nd_in,nq_in,nla,nlink
      write(iuo,'(/," ana_ehgts:",/,/," beta,nlink,nd,nq,nla:",
     &  1F16.12,I9,2I3,4I5)') beta,nlink,nd_in,nq_in,nla
      write(iuo,'(" nequi,nrpt,nmeas:",20X,I9,I6,I10)') nequi,nrpt,nmeas
      if(nlink.ne.mlink) stop "ana_ehgts: nlink.ne.mlink."
      call razero(hasum,izero,nlink)
      do irpt=1,nrpt
        read(iud1) ha
        do ilink=0,nlink
          hasum(ilink)=hasum(ilink)+ha(ilink)
        enddo
      enddo

      call razero(ha,izero,nlink)
      call razero(hbm,izero,nlink)
      call razero(hbe,izero,nlink)
      rewind iud1
      read(iud1) beta_in,nd_in,nq_in,nla,nlink
      do irpt=0,nrpt
        if(irpt.ge.1) read(iud1) ha
        do ilink=0,nlink
          haj(ilink)=hasum(ilink)-ha(ilink)
        enddo
        delb0=beta
        beta1=beta
        iter=0
1       iter=iter+1 ! Iterate for equal heights double peak:
          call double_peak(mlink,haj,max1,min0,max2,wght1,wght2)
          delb=log(haj(max1)/haj(max2))/(two*(max2-max1))
          eps=abs(delb/beta)
          if(abs(delb).ge.abs(delb0)) stop "|delb|.ge.|delb0|."
          beta2=beta1+delb 
          call potts_rwght(mlink,haj,hae,beta1,beta2,hbj,hae)
          delb0=delb ! result for hae not not needed. hbe below.
          beta1=beta2
          do ilink=0,mlink
            haj(ilink)=hbj(ilink)
          enddo
        if(eps.gt.em8) goto 1 ! Equal heights at beta2.

        bj(irpt)=beta2
        call double_peak(mlink,haj,maxa(1),min0,maxa(2),wght1,wght2)
        Ratj(irpt)=haj(max1)/haj(min0)
        actlj(irpt)=potts_actl(mlink,haj)
        do i=1,2
          do j=1,3
            x(j)=(maxa(i)+j-2)*one
            y(j)=haj(maxa(i)+j-2)
          enddo
          call parabola(x,y,a,b,c,xext(i),y)
        enddo
        if(nint(xext(1)).ne.maxa(1)) stop "ana_ehgts: xext(1) false."
        if(nint(xext(2)).ne.maxa(2)) stop "ana_ehgts: xext(2) false."
        d_actlj(irpt)=(xext(2)-xext(1))/mlink
        factor=nlink/histsum(izero,nlink,hbj) ! Normalization factor.
        if(irpt.eq.0) then
          do ilink=0,mlink
            hbm(ilink)=factor*hbj(ilink)
          enddo
        else
          do ilink=0,mlink
            hbe(ilink)=hbe(ilink)+(hbm(ilink)-factor*hbj(ilink))**2
          enddo
        endif
      enddo
      close(iud1)
 
      call stebj0(nrpt,bj(1),bjm,bv,be)
      write(iuo,'(/," Equal heights bm,bjm,be:",3F14.7)') bj(0),bjm,be
      open(iud1,file="pb"//cd//"d"//cq//"q"//cl//".d",
     &     form="formatted",status="unknown")
      hbsum=zero
      do ilink=0,mlink
        if(hbm(ilink).gt.em12) then
          act=ilink/(nlink*one)
          hbe(ilink)=sqrt((nrpt-1)*hbe(ilink)/nrpt)
          write(iud1,'(I10,3G15.6)') ilink,act,hbm(ilink),hbe(ilink)
          hbsum=hbsum+hbm(ilink)
        end if
      end do
      close(iud1)
      if(nint(hbsum).ne.nlink) stop "ana_ehgts: hbsum.ne.nlink."
 
      call stebj0(nrpt,Ratj(1),Ratjm,Rv,Rate)
      open(iud1,file="beta_ehgts.d",form="formatted",
     &     status="unknown",access="append")
      write(iud1,'(I9,2F14.6,2G16.7)') nla(1),bj(0),be,Ratj(0),Rate
      close(iud1)

      call stebj0(nrpt,actlj(1),actljm,av,actle)
      call stebj0(nrpt,d_actlj(1),d_actljm,av,d_actle)
      open(iud1,file="act_ehgts.d",form="formatted",
     &     status="unknown",access="append")
      write(iud1,'(I9,4F15.7)') nla(1),actlj(0),actle,d_actlj(0),d_actle
      close(iud1)

      stop
      end

      include '../../Libs/Fortran/double_peak.f'
      include '../../Libs/Fortran/histsum.f'
      include '../../Libs/Fortran/parabola.f'
      include '../../Libs/Fortran/potts_actl.f'
      include '../../Libs/Fortran/potts_rwght.f'
      include '../../Libs/Fortran/razero.f'
      include '../../Libs/Fortran/steb0.f'
      include '../../Libs/Fortran/stebj0.f'
