      program ana_h3d3q ! Bernd Berg Aug 4 2005.
C Prepares energy histogram plots and calculates average energy (action).
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      parameter(n0=0) 
      character cd*1,cq*2,cl*3
      include 'lat.par'
      include 'mc.par'
      include 'potts.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      include 'lat.dat'
      dimension ham(0:mlink),hae(0:mlink),actl(nrpt)
 
      write(cd,'(I1.1)') nd ! Prepare to read the data.
      write(cq,'(I2.2)') nq
      write(cl,'(I3.3)') nla(1)
      open(iud1,file="p"//cd//"d"//cq//"q"//cl//".D",
     &     form="unformatted",status="old")
      read(iud1) beta_in,nd_in,nq_in,nla,nlink
      write(iuo,'(/," ana_h3d3q:",/,/," beta,nlink,nd,nq,nla:",
     &  1F16.12,I9,2I3,4I5)') beta,nlink,nd_in,nq_in,nla
      write(iuo,'(" nequi,nrpt,nmeas:",20X,I9,I6,I10)') nequi,nrpt,nmeas
      if(nlink.ne.mlink) stop "ana_h3d3q: nlink.ne.mlink."

      call razero(ham,n0,nlink)
      do irpt=1,nrpt
        read(iud1) ha
        do ilink=0,nlink
          ham(ilink)=ham(ilink)+ha(ilink)
        enddo
      enddo
      factor=nlink/histsum(n0,nlink,ham)
      do ilink=0,nlink
        ham(ilink)=factor*ham(ilink)
      enddo

      rewind iud1
      read(iud1) beta_in,nd_in,nq_in,nla,nlink
      call razero(hae,n0,nlink)
      do irpt=1,nrpt
        read(iud1) ha
        actl(irpt)=potts_actl(nlink,ha)
        factor=nlink/histsum(n0,nlink,ha)
        do ilink=0,nlink
          hae(ilink)=hae(ilink)+(factor*ha(ilink)-ham(ilink))**2
        enddo
      enddo
      close(iud1)
 
      open(iud1,file="pa"//cd//"d"//cq//"q"//cl//".d",
     & form="formatted",status="unknown")
      hasum=zero
      do ilink=0,nlink
        hasum=hasum+ham(ilink)
        hae(ilink)=sqrt(hae(ilink)/(nrpt*(nrpt-1)))
        if(ham(ilink).gt.EM12) then
          actn=ilink/(nlink*one)
          es=nd*two*((one/nq)-actn) ! Internal energy per site.
          write(iud1,'(I10,4G15.6)') ilink,actn,es,ham(ilink),hae(ilink)
        end if
      end do
      close(iud1)
      write(iuo,'(" histogram on pa*.d, hasum =",G15.6)') hasum
 
      call steb0(nrpt,actl,actlm,av,actlme)
      write(iuo,'(" actlm =",F16.9,"  +/-",F16.9)') actlm,actlme
      em=nd*two*((one/nq)-actlm) ! Internal energy per site.
      ee=nd*two*actlme
      write(iuo,'(" em    =",F16.9,"  +/-",F16.9,/)') em,ee
 
      stop
      end

      include '../../Libs/Fortran/histsum.f'
      include '../../Libs/Fortran/potts_actl.f'
      include '../../Libs/Fortran/razero.f'
      include '../../Libs/Fortran/steb0.f'
