      program potts_hist ! Bernd Berg Dec 26 2000.
C MC Metropolis production run. Energy (action variable) histograms.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      parameter(lpri=.true.)
      character cd*1,cq*2,cl*3
      include 'lat.par'
      include 'mc.par'
      include 'potts.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      include 'lat.dat'
C
      call potts_init(lpri) ! Initialize Potts Metropolis MC:
C
      do iequi=1,nequi      ! Sweeps for reaching equilibrium.
        call potts_met
      end do
      acpt=acpt/(one*nequi)/(one*ms)
C
      write(cd,'(I1.1)') nd
      write(cq,'(I2.2)') nq
      write(cl,'(I3.3)') nla(1)
      open(iud1,file="p"//cd//"d"//cq//"q"//cl//".D",
     &     form="unformatted",status="unknown")
      write(iud1) beta,nd,nq,nla,mlink,nequi,nrpt,nmeas,iseed1,iseed2
      do irpt=1,nrpt ! nrpt repititions of nmeas measurement sweeps.
        call write_progress(iud2,"irpt,iact,acpt:",irpt,iact,acpt)
        acpt=zero
        call razero(ha,izero,mlink)
        do imeas=1,nmeas
          do isw=1,nsw
            call potts_met
          enddo
        enddo
        acpt=acpt/(one*nmeas)/(one*ms)/(one*nsw)
        write(iuo,'("irpt,iact,acpt:",2I12,F9.3)') irpt,iact,acpt
        write(iud1) ha,acpt,irpt
      end do
      close(iud1)
C
      stop
      end

      include '../../Libs/Fortran_par/potts_init.f'
      include '../../Libs/Fortran_par/potts_met.f'

      include '../../Libs/Fortran/ipointer.f'
      include '../../Libs/Fortran/isfun.f'
      include '../../Libs/Fortran/ixcor.f'
      include '../../Libs/Fortran/lat_init.f'
      include '../../Libs/Fortran/nsfun.f'
      include '../../Libs/Fortran/write_progress.f'

      include '../../Libs/Fortran/potts_act.f'
      include '../../Libs/Fortran/potts_act_tab.f'
      include '../../Libs/Fortran/potts_order.f'
      include '../../Libs/Fortran/potts_ran.f'
      include '../../Libs/Fortran/potts_wght.f'
      include '../../Libs/Fortran/razero.f'

      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/rmasave.f'
